import subprocess, os, re, csv, time, sys

pattern = r'.+\.csv$'
folder_name = 'spiskovi'

path = os.path.join( '.', folder_name )
if not os.path.exists( path ):
        print( 'Folder', folder_name,'nije pronadjen' )
        exit()

pera = subprocess.Popen( [str(sys.executable),'pera.py'] )
mika = subprocess.Popen( [str(sys.executable),'mika.py'])

while pera.poll() != 0 and mika.poll() != 0:
        print('Procesi se jos uvek izvrsavaju...')
        time.sleep(3)

print('Procesi su zavrseni')
  
os.chdir( path )
files = os.listdir()

if files == []:
    print("Folder je prazan!")
    exit()

csv_files = []

files.sort()

regex = re.compile( pattern )
for file in files:
     reObj = regex.search( file )
     if reObj is not None:
         csv_files += [ reObj.group() ]

if csv_files == []:
    print("Nije pronadjen ni jedan .json file")
    exit()

lista_najboljih = []
for file in csv_files:
    najbolji_file = open( file )
    najbolji_reader = csv.DictReader( najbolji_file , quotechar='"' )

    for student in najbolji_reader:
        lista_najboljih += [ ( student['Ime'], student['Prezime'], student['Indeks'],  student['Prosek'], student['Grupa'] ) ]

if lista_najboljih == []:
    print("Nije pronadjen ni jedan student")
    exit()    

lista_najboljih.sort( key = lambda x: float( x[3] ) )

ime, prezime, index, prosek, grupa = lista_najboljih[-1]
print('Najbolji student:')
print( ime, prezime, index, prosek, grupa )
