import bs4, os, re, csv, json

pattern = r'.+\.json$'
folder_name = 'spiskovi'

path = os.path.join( '.', folder_name )
if not os.path.exists( path ):
    print( 'Folder', folder_name,'nije pronadjen' )
    exit()
    
os.chdir( path )
files = os.listdir()

if files == []:
    print("Folder je prazan!")
    exit()

regex = re.compile( pattern )
groups = []
groups_info = []

files.sort()

for file in files:
     reObj = regex.search( file )
     if reObj is not None:
         groups += [ reObj.group() ]

if groups == []:
    print('Nije pronadjen ni jedan .json file')
    exit()

for group_name in groups:
    group_file = open( group_name )
    
    try:
        group = json.load( group_file )
    except:
        print("Neispravan fajl:", group_name)
        group_file.close()
        continue
    
    group_file.close()

    if not "studenti" in group:
        continue

    studenti_info = dict()
    for student in group['studenti']['student']:
        ime = student["ime"]
        prezime = student["prezime"]
        
        ocene = list( map( int, student["ocene"] ) )
        broj_ocena = len( ocene )
        prosek = -1
        
        if broj_ocena != 0:
            prosek = sum( ocene ) / broj_ocena
                
        indeks = student["indeks"]
        if studenti_info.get( indeks ) == None:
            studenti_info[ indeks ] = ( ime, prezime, prosek, group_name[:-5] )
        else:
            print("Student sa indeksom %s je vec unet!" % indeks )
            
    groups_info += [ studenti_info ]

if groups_info == []:
    print('Nije pronadjen ni jedan student')
    exit()
    
polja = [ 'Ime', 'Prezime', 'Indeks', 'Prosek', 'Grupa' ]    
najbolji_file = open('Mika.csv', 'w', newline = '' )
najbolji_writer = csv.writer( najbolji_file )
najbolji_writer.writerow( polja )

for group_info in groups_info:
    items = list( group_info.items() )
    items.sort( key = lambda x: x[1][2] )
    
    najbolji = list( items[-1][1][:2] ) + [ items[-1][0] ] + list( items[-1][1][2:] )
    najbolji_writer.writerow( najbolji )

najbolji_file.close()
os.chdir('..')
